]> de.git.xonotic.org Git - xonotic/xonotic.git/blob - misc/tools/xonotic-map-compiler-autobuild
Merge remote branch 'origin/terencehill/mapping_update'
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
1 #!/bin/sh
2
3 set -e
4
5 bspdir="$PWD/data"
6 url_http=http://beta.xonotic.org/autobuild-bsp/
7 url_ssh=xonotic-beta:autobuild-bsp/
8 build_cachedir="$HOME/xonotic-map-compiler.cache/"
9 screenshot_cachedir="$HOME/xonotic-map-screenshot.cache/"
10 build_override="-bsp_timeout 5400 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
11 screenshot_override="9 900 5 +g_ctf 1"
12
13 getthemap_fail=false
14
15 allmaps()
16 {
17         commithash=$1
18         shift
19         for F in `git show "${commithash}:maps/"`; do
20                 case "$F" in
21                         *.map.options)
22                                 ;;
23                         *)
24                                 continue
25                                 ;;
26                 esac
27                 M=${F%.map.options}
28                 blobhash=`git rev-parse --revs-only "${commithash}:maps/$M.map.options" || true`-`git rev-parse --revs-only "${commithash}:maps/$M.map" || true`
29                 case "$blobhash" in
30                         -*)
31                                 ;;
32                         *-)
33                                 ;;
34                         *)
35                                 "$@" "$M" "$blobhash" "$commithash"
36                                 ;;
37                 esac
38         done
39 }
40
41 pre2spam()
42 {
43         map=$1
44         url=$2
45         branch=$3
46         hash=$4
47
48         branch=${branch##refs/heads/}
49         branch=${branch##refs/remotes/}
50         branch=${branch##origin/}
51         hash=`echo "$hash" | cut -c 1-7`
52
53         echo "[$branch $hash] starting map compile of $map"
54 }
55
56 ss2spam()
57 {
58         map=$1
59         url=$2
60         branch=$3
61         hash=$4
62         status=$5
63
64         branch=${branch##refs/heads/}
65         branch=${branch##refs/remotes/}
66         branch=${branch##origin/}
67         hash=`echo "$hash" | cut -c 1-7`
68
69         s_error=
70
71         if [ "$status" -ne 0 ]; then
72                 s_error="exited with status $status"
73         fi
74
75         if [ -n "$s_error" ]; then
76                 echo "[$branch $hash] \ 34screenshots of $map could not be made: $s_error"
77         else
78                 echo "[$branch $hash] screenshots of $map are available on $url"
79         fi
80 }
81
82 log2spam()
83 {
84         map=$1
85         url=$2
86         branch=$3
87         hash=$4
88         status=$5
89         time=$6
90
91         hash=`echo "$hash" | cut -c 1-7`
92
93         branch=${branch##refs/heads/}
94         branch=${branch##refs/remotes/}
95         branch=${branch##origin/}
96
97         s_samplesize=
98         s_failshaders=
99         s_leaked=
100         s_error=
101
102         if [ "$status" -ne 0 ]; then
103                 s_error="exited with status $status"
104         fi
105         while IFS= read -r L; do
106                 case "$L" in
107                         WARNING:\ surface\ at\ *\ too\ large\ for\ desired\ samplesize*)
108                                 s=${L##* }
109                                 if [ -z "$s_samplesize" ] || [ "$s" -gt "$s_samplesize" ]; then
110                                         s_samplesize=$s
111                                 fi
112                                 ;;
113                         WARNING:\ Couldn\'t\ find\ image\ for\ shader\ textures/NULL)
114                                 # radiant stupid
115                                 ;;
116                         WARNING:\ Couldn\'t\ find\ image\ for\ shader\ *)
117                                 s_failshaders="$s_failshaders ${L##* }"
118                                 ;;
119                         ERROR:\ *)
120                                 if [ -z "$s_error" ]; then
121                                         s_error=$L
122                                 fi
123                                 ;;
124                         '******* leaked *******')
125                                 s_leaked=1
126                                 ;;
127                         '************ ERROR ************')
128                                 IFS= read -r s_error
129                                 ;;
130                 esac
131         done
132         s_failshaders=`echo "$s_failshaders" | sed "s, textures/, ,g"`
133         s_failshaders=${s_failshaders# }
134         if [ -n "$s_error" ]; then
135                 echo -n "[$branch $hash] \ 34failed"
136         else
137                 echo -n "[$branch $hash] finished"
138         fi
139         echo -n " map compile of $map ($url): $time sec"
140         if [ -n "$s_samplesize" ]; then
141                 echo -n ", FIX samplesize >= $s_samplesize"
142         fi
143         if [ -n "$s_failshaders" ]; then
144                 if [ -n "`echo "$s_failshaders" | cut -d ' ' -f 4-`" ]; then
145                         s_failshaders="`echo "$s_failshaders" | cut -d ' ' -f 1-3`..."
146                 fi
147                 echo -n ", FIX shaders $s_failshaders"
148         fi
149         if [ -n "$s_leaked" ]; then
150                 echo -n ", FIX LEAK"
151         fi
152         if [ -n "$s_error" ]; then
153                 s_error=`echo "$s_error" | sed "s,$PWD/\?,,g"`
154                 echo -n ", ERROR: $s_error"
155         fi
156         echo
157 }
158
159 buildthemap()
160 {
161         REFNAME=$1
162         url=$2
163         M=$3
164         blobhash=$4
165         commithash=$5
166         if lwp-request -m HEAD "$url$M-$blobhash.pk3"; then
167                 continue
168         fi
169
170         git reset --hard
171         git clean -xfd
172         git checkout -f "$commithash"
173
174         if [ -n "$IRCSPAM" ]; then
175                 pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" | $IRCSPAM
176         fi
177         t0=`date +%s`
178         (
179                 cd maps
180                 sz=`grep '^size ' "$M.mapinfo" 2>/dev/null || true`
181                 if [ -n "$sz" ]; then
182                         minimap_override="-minimap + -minmax ${sz#size }"
183                 else
184                         minimap_override=
185                 fi
186                 ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` $minimap_override $build_override > "$M.log" 2>&1
187         )
188         status=$?
189         if ! [ -f "maps/$M.bsp" ]; then
190                 echo >>"$M.log" "ERROR: No BSP file"
191         fi
192         t1=`date +%s`
193         dt=$(($t1 - $t0))
194         if [ -n "$IRCSPAM" ]; then
195                 cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" "$status" "$dt" > "maps/$M.irc"
196         fi
197         zip -9r "$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
198         ln -snf "../$M-$blobhash.pk3" "$M.pk3" # from ALL branches, so beware!
199         cp "$M-$blobhash.pk3" "$M-full-$blobhash.pk3"
200         zip -9r "$M-full-$blobhash.pk3" `git diff --name-only --diff-filter=ACMRTUXB master...HEAD` || true
201         ln -snf "../$M-full-$blobhash.pk3" "$M-full.pk3" # from ALL branches, so beware!
202         rsync -vaSHP "$M-$blobhash.pk3" "$M-full-$blobhash.pk3" "$url_ssh"
203         rsync -vaSHP "$M.pk3" "$M-full.pk3" "$url_ssh""latest/"
204         if [ -n "$IRCSPAM" ]; then
205                 $IRCSPAM < "maps/$M.irc"
206         fi
207 }
208
209 screenshotthemap()
210 {
211         REFNAME=$1
212         url=$2
213         M=$3
214         blobhash=$4
215         commithash=$5
216         if lwp-request -m HEAD "$url$M-$blobhash/"; then
217                 continue
218         fi
219
220         if ! unzip -l "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp"; then
221                 # no BSP file
222                 continue
223         fi
224
225         rm -rf ~/.xonotic/data
226         mkdir -p ~/.xonotic/data
227         (
228                 cd ../..
229                 if [ -n "$DISPLAY" ]; then
230                         misc/tools/xonotic-map-screenshot "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\""
231                 else
232                         case "$DRIVER" in
233                                 gl)
234                                         startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- :8
235                                         ;;
236                                 soft|*)
237                                         startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"vid_soft 1" $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- /usr/bin/Xvfb :8 -screen 0 1024x768x24
238                                         ;;
239                         esac
240                 fi
241         ) 2>&1 | tee ~/.xonotic/data/autoscreenshot.log
242         good=false
243         if mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
244                 ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 0 > ~/.xonotic/data/"$M.ircss"
245         else
246                 mkdir "$M-$blobhash"
247                 ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 1 > ~/.xonotic/data/"$M.ircss"
248         fi
249         mv ~/.xonotic/data/"$M.ircss" "$M-$blobhash"/
250         mv ~/.xonotic/data/autoscreenshot.log "$M-$blobhash"/
251         chmod 1777 "$M-$blobhash"
252         ln -snf "../$M-$blobhash" "$M" # from ALL branches, so beware!
253         rsync -vaSHP "$M-$blobhash" "$url_ssh"
254         rsync -vaSHP "$M" "$url_ssh""latest/"
255         if [ -n "$IRCSPAM" ]; then
256                 $IRCSPAM < "$M-$blobhash/$M.ircss"
257         fi
258 }
259
260 getthemap()
261 {
262         url=$1
263         bspdir_old=$2
264         bspdir=$3
265         M=$4
266         blobhash=$5
267         commithash=$6
268         if mv "$bspdir_old/$M-$blobhash.pk3" "$bspdir/$M-$blobhash.pk3"; then
269                 if unzip -l "$bspdir/$M-$blobhash.pk3" >/dev/null 2>&1; then
270                         return 0
271                 fi
272         fi
273         if ! wget -c -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
274                 if ! curl -o "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
275                         rm -f "$bspdir/$M-$blobhash.pk3"
276                         echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
277                         getthemap_fail=true
278                         return 0
279                 fi
280         fi
281         if ! unzip -l "$bspdir/$M-$blobhash.pk3"; then
282                 rm -f "$bspdir/$M-$blobhash.pk3"
283                 echo "WARNING: could not download $url$M-$blobhash.pk3, invalid zip file"
284                 getthemap_fail=true
285                 return 0
286         fi
287 }
288
289 indexthemap()
290 {
291         REFNAME=$1
292         M=$2
293         blobhash=$3
294         commithash=$4
295         echo "$M $blobhash $commithash $REFNAME"
296 }
297
298 rundownload()
299 {
300         mkdir -p "$bspdir" "$bspdir.old"
301         for b in "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
302                 if [ -e "$b" ]; then
303                         mv "$b" "$bspdir.old"/
304                 fi
305         done
306         allmaps "HEAD" getthemap "$url_http" "$bspdir.old" "$bspdir"
307 }
308
309 branches()
310 {
311         git for-each-ref 'refs/remotes' | grep -vE '    refs/remotes/([^/]*/HEAD|.*/archived/.*)$'
312 }
313
314 runmakeindex()
315 {
316         cd data/xonotic-maps.pk3dir
317         branches | while read -r HASH TYPE REFNAME; do
318                 allmaps "$HASH" indexthemap "$REFNAME"
319         done
320         cd ../..
321 }
322
323 case "$1" in
324         build)
325                 cd data/xonotic-maps.pk3dir
326                 branches | while read -r HASH TYPE REFNAME; do
327                         if [ -f "$build_cachedir/$HASH" ]; then
328                                 continue
329                         fi
330                         allmaps "$HASH" buildthemap "$REFNAME" "$url_http"
331                         touch "$build_cachedir/$HASH"
332                 done
333                 git checkout -f master
334                 ;;
335         screenshot)
336                 runmakeindex > "branches.idx.new"
337                 rsync -vaSHP "branches.idx.new" "$url_ssh""branches.idx.new"
338                 rm -f "branches.idx.new"
339                 cd data/xonotic-maps.pk3dir
340                 branches | while read -r HASH TYPE REFNAME; do
341                         if [ -f "$screenshot_cachedir/$HASH" ]; then
342                                 continue
343                         fi
344
345                         git reset --hard
346                         git clean -xfd
347                         git checkout -f "$HASH"
348
349                         rundownload
350                         if $getthemap_fail; then
351                                 continue
352                         fi
353
354                         allmaps "$HASH" screenshotthemap "$REFNAME" "$url_http"
355
356                         touch "$screenshot_cachedir/$HASH"
357                 done
358                 git checkout -f master
359                 ;;
360         makeindex)
361                 runmakeindex
362                 ;;
363         download)
364                 if ! cd data/xonotic-maps.pk3dir >/dev/null 2>&1; then
365                         echo "data/xonotic-maps.pk3dir does not exist, not downloading"
366                         exit 0
367                 fi
368                 rundownload
369                 cd ../..
370                 echo "List of maps that got deleted (if any) and currently are in $bspdir.old:"
371                 ls -l "$bspdir.old" || true
372                 ;;
373         download-latest)
374                 mkdir -p "$bspdir"
375                 cd "$bspdir"
376                 rm -f *-????????????????????????????????????????-????????????????????????????????????????.pk3
377                 wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url_http""latest"
378                 ;;
379         log2spam-test)
380                 log2spam "mapname" "http://mapurl" "branch" "commit" "0"
381                 ;;
382 esac